#define Uses_TApplication
#define Uses_TScreen
#define Uses_TMouse
#define Uses_TTitleBar
#define Uses_TStaticText
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TKeys
#define Uses_TDeskTop
#define Uses_TEvent
#include <tv.h>

#include "ttitlbar.h"

const cmScreenMode = 100;

class TMyApp : public TApplication
	{
	public:
		TMyApp();

		static TMenuBar *initMenuBar( TRect r );
		static TDeskTop *initDeskTop( TRect r );

		virtual void handleEvent( TEvent& event );
	};

TMyApp::TMyApp() :
		TProgInit( &TMyApp::initStatusLine, &TMyApp::initMenuBar,
				&TMyApp::initDeskTop )
	{
	TRect r = getExtent();
	r.b.y = r.a.y+1;
	insert( new TTitleBar(r, "\003Sample Title Bar") );
	TMouse::setRange( TRect(0,1,TScreen::screenWidth-1,
		TScreen::screenHeight-1) );
	}

TMenuBar *TMyApp::initMenuBar( TRect r )
	{
	r.a.y++;
	r.b.y = r.a.y+1;
	return new TMenuBar( r,
		*new TSubMenu( "~F~ile", 0 )+
			*new TMenuItem( "~C~hange screen mode", cmScreenMode, kbNoKey,
				hcNoContext, 0 )+
			*new TMenuItem( "E~x~it", cmQuit, kbAltX, hcNoContext, 0 )
		);
	}

TDeskTop *TMyApp::initDeskTop( TRect r )
	{
	r.a.y += 2;
	r.b.y--;
	return new TDeskTop( r );
	}

void TMyApp::handleEvent( TEvent& event )
	{
	TApplication::handleEvent(event);
	if( event.what == evCommand && event.message.command == cmScreenMode )
		{
		setScreenMode( TScreen::screenMode ^ TDisplay::smFont8x8 );

		// Following not required (?) for TV1.03
		TMouse::setRange( TScreen::screenWidth-1,TScreen::screenHeight-1 );

		clearEvent(event);
		}
	}

int main()
	{
	TMyApp app;
	app.run();
	app.shutDown();
	return 0;
	}
